## srt 1.4.4

=== CMakeLists.txt ===
#
# SRT - Secure, Reliable, Transport
# Copyright (c) 2018 Haivision Systems Inc.
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
#

cmake_minimum_required (VERSION 2.8.12 FATAL_ERROR)
set (SRT_VERSION 1.4.4)

set (CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts")
include(haiUtil) # needed for set_version_variables
# CMake version 3.0 introduced the VERSION option of the project() command
# to specify a project version as well as the name.
if(${CMAKE_VERSION} VERSION_LESS "3.0.0")
  project(SRT C CXX)
  # Sets SRT_VERSION_MAJOR, SRT_VERSION_MINOR, SRT_VERSION_PATCH
  set_version_variables(SRT_VERSION ${SRT_VERSION})
else()
  cmake_policy(SET CMP0048 NEW)
  # Also sets SRT_VERSION_MAJOR, SRT_VERSION_MINOR, SRT_VERSION_PATCH
  project(SRT VERSION ${SRT_VERSION} LANGUAGES C CXX)
endif()

include(FindPkgConfig)
# XXX See 'if (MINGW)' condition below, may need fixing.
include(FindThreads)
include(CheckFunctionExists)

# Platform shortcuts
string(TOLOWER ${CMAKE_SYSTEM_NAME} SYSNAME_LC)
set_if(DARWIN	   (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
					OR (${CMAKE_SYSTEM_NAME} MATCHES "iOS")
					OR (${CMAKE_SYSTEM_NAME} MATCHES "tvOS")
					OR (${CMAKE_SYSTEM_NAME} MATCHES "watchOS"))
set_if(LINUX       ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
set_if(BSD         ${SYSNAME_LC} MATCHES "bsd$")
set_if(MICROSOFT   WIN32 AND (NOT MINGW AND NOT CYGWIN))
set_if(GNU         ${CMAKE_SYSTEM_NAME} MATCHES "GNU")
set_if(ANDROID     ${SYSNAME_LC} MATCHES "android")
set_if(SUNOS       "${SYSNAME_LC}" MATCHES "sunos")
set_if(POSIX       LINUX OR DARWIN OR BSD OR SUNOS OR ANDROID OR (CYGWIN AND CYGWIN_USE_POSIX))
set_if(SYMLINKABLE LINUX OR DARWIN OR BSD OR SUNOS OR CYGWIN OR GNU)

# Not sure what to do in case of compiling by MSVC.
# This will make installdir in C:\Program Files\SRT then
# inside "bin" and "lib64" directories. At least this maintains
# the current status. Shall this be not desired, override values
# of CMAKE_INSTALL_BINDIR, CMAKE_INSTALL_LIBDIR and CMAKE_INSTALL_INCLUDEDIR.
if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	include(GNUInstallDirs)
endif()

# The CMAKE_BUILD_TYPE seems not to be always set, weird.
if (NOT DEFINED ENABLE_DEBUG)

	if (CMAKE_BUILD_TYPE STREQUAL "Debug")
		set (ENABLE_DEBUG ON)
	else()
		set (ENABLE_DEBUG OFF)
	endif()
endif()

# Set CMAKE_BUILD_TYPE properly, now that you know
# that ENABLE_DEBUG is set as it should.

if (ENABLE_DEBUG EQUAL 2)
	set (CMAKE_BUILD_TYPE "RelWithDebInfo")
elseif (ENABLE_DEBUG) # 1, ON, YES, TRUE, Y, or any other non-zero number
	set (CMAKE_BUILD_TYPE "Debug")
else()
	set (CMAKE_BUILD_TYPE "Release")
endif()

message(STATUS "BUILD TYPE: ${CMAKE_BUILD_TYPE}")

getVarsWith(ENFORCE_ enforcers)
foreach(ef ${enforcers})
	set (val ${${ef}})
	if (NOT val STREQUAL "")
		set(val =${val})
	endif()
	string(LENGTH ENFORCE_ pflen)
	string(LENGTH ${ef} eflen)
	math(EXPR alen ${eflen}-${pflen})
	string(SUBSTRING ${ef} ${pflen} ${alen} ef)
	message(STATUS "FORCED PP VARIABLE: ${ef}${val}")
	add_definitions(-D${ef}${val})
endforeach()

# NOTE: Known options you can change using ENFORCE_ variables:

# SRT_ENABLE_ECN 1                /* Early Congestion Notification (for source bitrate control) */
# SRT_DEBUG_TSBPD_OUTJITTER 1     /* Packet Delivery histogram */
# SRT_DEBUG_TSBPD_DRIFT 1         /* Debug Encoder-Decoder Drift) */
# SRT_DEBUG_TSBPD_WRAP 1          /* Debug packet timestamp wraparound */
# SRT_DEBUG_TLPKTDROP_DROPSEQ 1
# SRT_DEBUG_SNDQ_HIGHRATE 1
# SRT_DEBUG_BONDING_STATES 1
# SRT_DEBUG_RTT 1                 /* RTT trace */
# SRT_MAVG_SAMPLING_RATE 40       /* Max sampling rate */

# option defaults
set(ENABLE_HEAVY_LOGGING_DEFAULT OFF)

# Always turn logging on if the build type is debug
if (ENABLE_DEBUG)
	set(ENABLE_HEAVY_LOGGING_DEFAULT ON)
endif()


set(ENABLE_STDCXX_SYNC_DEFAULT OFF)
set(ENABLE_MONOTONIC_CLOCK_DEFAULT OFF)
set(MONOTONIC_CLOCK_LINKLIB "")
if (MICROSOFT)
	set(ENABLE_STDCXX_SYNC_DEFAULT ON)
elseif (POSIX)
	test_requires_clock_gettime(ENABLE_MONOTONIC_CLOCK_DEFAULT MONOTONIC_CLOCK_LINKLIB)
endif()


# options
option(CYGWIN_USE_POSIX "Should the POSIX API be used for cygwin. Ignored if the system isn't cygwin." OFF)
option(ENABLE_CXX11 "Should the c++11 parts (srt-live-transmit) be enabled" ON)
option(ENABLE_APPS "Should the Support Applications be Built?" ON)
option(ENABLE_EXPERIMENTAL_BONDING "Should the EXPERIMENTAL bonding functionality be enabled?" OFF)
option(ENABLE_TESTING "Should the Developer Test Applications be Built?" OFF)
option(ENABLE_PROFILE "Should instrument the code for profiling. Ignored for non-GNU compiler." $ENV{HAI_BUILD_PROFILE})
option(ENABLE_LOGGING "Should logging be enabled" ON)
option(ENABLE_HEAVY_LOGGING "Should heavy debug logging be enabled" ${ENABLE_HEAVY_LOGGING_DEFAULT})
option(ENABLE_HAICRYPT_LOGGING "Should logging in haicrypt be enabled" 0)
option(ENABLE_SHARED "Should libsrt be built as a shared library" ON)
option(ENABLE_STATIC "Should libsrt be built as a static library" ON)
option(ENABLE_RELATIVE_LIBPATH "Should application contain relative library paths, like ../lib" OFF)
option(ENABLE_GETNAMEINFO "In-logs sockaddr-to-string should do rev-dns" OFF)
option(ENABLE_UNITTESTS "Enable unit tests" OFF)
option(ENABLE_ENCRYPTION "Enable encryption in SRT" ON)
option(ENABLE_CXX_DEPS "Extra library dependencies in srt.pc for the CXX libraries useful with C language" ON)
option(USE_STATIC_LIBSTDCXX "Should use static rather than shared libstdc++" OFF)
option(ENABLE_INET_PTON "Set to OFF to prevent usage of inet_pton when building against modern SDKs while still requiring compatibility with older Windows versions, such as Windows XP, Windows Server 2003 etc." ON)
option(ENABLE_CODE_COVERAGE "Enable code coverage reporting" OFF)
option(ENABLE_MONOTONIC_CLOCK "Enforced clock_gettime with monotonic clock on GC CV" ${ENABLE_MONOTONIC_CLOCK_DEFAULT})
option(ENABLE_STDCXX_SYNC "Use C++11 chrono and threads for timing instead of pthreads" ${ENABLE_STDCXX_SYNC_DEFAULT})
option(USE_OPENSSL_PC "Use pkg-config to find OpenSSL libraries" ON)
option(USE_BUSY_WAITING "Enable more accurate sending times at a cost of potentially higher CPU load" OFF)
option(USE_GNUSTL "Get c++ library/headers from the gnustl.pc" OFF)
option(ENABLE_SOCK_CLOEXEC "Enable setting SOCK_CLOEXEC on a socket" ON)

option(ENABLE_CLANG_TSA "Enable Clang Thread Safety Analysis" OFF)

# NOTE: Use ATOMIC_USE_SRT_SYNC_MUTEX and will override the auto-detection of the
#  Atomic implemetation in srtcore/atomic.h.
option(ATOMIC_USE_SRT_SYNC_MUTEX "Use srt::sync::Mutex to Implement Atomics" OFF)
if (ATOMIC_USE_SRT_SYNC_MUTEX)
   add_definitions(-DATOMIC_USE_SRT_SYNC_MUTEX=1)
endif()

set(TARGET_srt "srt" CACHE STRING "The name for the SRT library")

# Use application-defined group reader
# (currently the only one implemented)
add_definitions(-DSRT_ENABLE_APP_READER)

# XXX This was added once as experimental, it is now in force for
# write-blocking-mode sockets. Still unclear if all issues around
# closing while data still not written are eliminated.
add_definitions(-DSRT_ENABLE_CLOSE_SYNCH)

if (NOT ENABLE_LOGGING)
	set (ENABLE_HEAVY_LOGGING OFF)
	message(STATUS "LOGGING: DISABLED")
else()
	if (ENABLE_HEAVY_LOGGING)
		message(STATUS "LOGGING: HEAVY")
	else()
		message(STATUS "LOGGING: ENABLED")
	endif()
endif()

if (USE_BUSY_WAITING)
	message(STATUS "USE_BUSY_WAITING: ON")
	list(APPEND SRT_EXTRA_CFLAGS "-DUSE_BUSY_WAITING=1")
else()
	message(STATUS "USE_BUSY_WAITING: OFF (default)")
endif()

if ( CYGWIN AND NOT CYGWIN_USE_POSIX )
	set(WIN32 1)
	set(CMAKE_LEGACY_CYGWIN_WIN32 1)
	add_definitions(-DWIN32=1 -DCYGWIN=1)
	message(STATUS "HAVE CYGWIN. Setting backward compat CMAKE_LEGACY_CYGWIN_WIN32 and -DWIN32")
endif()

if (NOT USE_ENCLIB)
	if (USE_GNUTLS)
		message("NOTE: USE_GNUTLS is deprecated. Use -DUSE_ENCLIB=gnutls instead.")
		set (USE_ENCLIB gnutls)
	else()
		set (USE_ENCLIB openssl)
	endif()

endif()

set(USE_ENCLIB "${USE_ENCLIB}" CACHE STRING "The crypto library that SRT uses")
set_property(CACHE USE_ENCLIB PROPERTY STRINGS "openssl" "gnutls" "mbedtls")

# Make sure DLLs and executabes go to the same path regardles of subdirectory
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if (NOT DEFINED WITH_COMPILER_TYPE)

	# This is for a case when you provided the prefix, but you didn't
	# provide compiler type. This option is in this form predicted to work
	# only on POSIX systems. Just typical compilers for Linux and Mac are
	# included. 
	if (DARWIN)
		set (WITH_COMPILER_TYPE clang)
	elseif (POSIX) # Posix, but not DARWIN
		set(WITH_COMPILER_TYPE gcc)
	else()
		get_filename_component(WITH_COMPILER_TYPE ${CMAKE_C_COMPILER} NAME)
	endif()
	set (USING_DEFAULT_COMPILER_PREFIX 1)
endif()

if (NOT USING_DEFAULT_COMPILER_PREFIX OR DEFINED WITH_COMPILER_PREFIX)
	message(STATUS "Handling compiler with PREFIX=${WITH_COMPILER_PREFIX} TYPE=${WITH_COMPILER_TYPE}")

	parse_compiler_type(${WITH_COMPILER_TYPE} COMPILER_TYPE COMPILER_SUFFIX)

	if (${COMPILER_TYPE} STREQUAL gcc)
		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}gcc${COMPILER_SUFFIX})
		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}g++${COMPILER_SUFFIX})
		set (HAVE_COMPILER_GNU_COMPAT 1)
	elseif (${COMPILER_TYPE} STREQUAL cc)
		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}cc${COMPILER_SUFFIX})
		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}c++${COMPILER_SUFFIX})
		set (HAVE_COMPILER_GNU_COMPAT 1)
	elseif (${COMPILER_TYPE} STREQUAL icc)
		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}icc${COMPILER_SUFFIX})
		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}icpc${COMPILER_SUFFIX})
		set (HAVE_COMPILER_GNU_COMPAT 1)
	else()
		# Use blindly <command> for C compiler and <command>++ for C++.
		# At least this matches clang.
		set (CMAKE_C_COMPILER ${WITH_COMPILER_PREFIX}${WITH_COMPILER_TYPE})
		set (CMAKE_CXX_COMPILER ${WITH_COMPILER_PREFIX}${COMPILER_TYPE}++${COMPILER_SUFFIX})
		if (${COMPILER_TYPE} STREQUAL clang)
			set (HAVE_COMPILER_GNU_COMPAT 1)
		endif()
	endif()
	message(STATUS "Compiler type: ${WITH_COMPILER_TYPE}. C: ${CMAKE_C_COMPILER}; C++: ${CMAKE_CXX_COMPILER}")
	unset(USING_DEFAULT_COMPILER_PREFIX)
else()
	message(STATUS "No WITH_COMPILER_PREFIX - using C++ compiler ${CMAKE_CXX_COMPILER}")
endif()


if (DEFINED WITH_SRT_TARGET)
	set (TARGET_haisrt ${WITH_SRT_TARGET})
endif()

# When you use crosscompiling, you have to take care that PKG_CONFIG_PATH
# and CMAKE_PREFIX_PATH are set properly.

# symbol exists in win32, but function does not.
if(WIN32)
	if(ENABLE_INET_PTON)
		set(CMAKE_REQUIRED_LIBRARIES ws2_32)
		check_function_exists(inet_pton HAVE_INET_PTON)
		add_definitions(-D_WIN32_WINNT=0x0600)
	else()
		add_definitions(-D_WIN32_WINNT=0x0501)
	endif()
else()
	check_function_exists(inet_pton HAVE_INET_PTON)
endif()
if (DEFINED HAVE_INET_PTON)
	add_definitions(-DHAVE_INET_PTON=1)
endif()

# Defines HAVE_PTHREAD_GETNAME_* and HAVE_PTHREAD_SETNAME_*
include(FindPThreadGetSetName)
FindPThreadGetSetName()

if (ENABLE_MONOTONIC_CLOCK)
	if (NOT ENABLE_MONOTONIC_CLOCK_DEFAULT)
		message(FATAL_ERROR "Your platform does not support CLOCK_MONOTONIC. Build with -DENABLE_MONOTONIC_CLOCK=OFF.")
	endif()
	set (WITH_EXTRALIBS "${WITH_EXTRALIBS} ${MONOTONIC_CLOCK_LINKLIB}")
	add_definitions(-DENABLE_MONOTONIC_CLOCK=1)
endif()

if (ENABLE_ENCRYPTION)
	if ("${USE_ENCLIB}" STREQUAL "gnutls")
		set (SSL_REQUIRED_MODULES "gnutls nettle")
		if (WIN32)
			if (MINGW)
				set (SSL_REQUIRED_MODULES "${SSL_REQUIRED_MODULES} zlib")
			endif()
		endif()

		pkg_check_modules (SSL REQUIRED ${SSL_REQUIRED_MODULES})

		add_definitions(
			-DUSE_GNUTLS=1
		)

		link_directories(
			${SSL_LIBRARY_DIRS}
		)
	elseif ("${USE_ENCLIB}" STREQUAL "mbedtls")
		add_definitions(-DUSE_MBEDTLS=1)
		if ("${SSL_LIBRARY_DIRS}" STREQUAL "")

=== debian/changelog ===
srt (1.4.4-4) UNRELEASED; urgency=medium

  * update

 -- Florian Ernst <florian@debian.org>  Thu, 16 Jun 2022 14:32:53 +0800

srt (1.4.4-4) unstable; urgency=medium

  * [00e65b3] restrict upstream unit testing to certain architectures

 -- Florian Ernst <florian@debian.org>  Sun, 13 Mar 2022 11:28:01 +0100

srt (1.4.4-3) unstable; urgency=medium

  * [759b832] enable upstream unit tests again, using libgtest-dev
  * [a0096b4] debian/tests/: add simple autopkgtest tests
  * [da46ba2] debian/rules: complete separation between -arch and -indep calls
  * [413e1de] debian/rules: drop trailing whitespace

 -- Florian Ernst <florian@debian.org>  Sat, 12 Mar 2022 15:30:35 +0100

srt (1.4.4-2) unstable; urgency=medium

  * [75ad4d7] don't require B-D-I python3-sphinx during clean
  * [604e728] debian/control: mark libsrt-doc 'Multi-Arch: foreign'

 -- Florian Ernst <florian@debian.org>  Thu, 03 Mar 2022 22:07:57 +0100

srt (1.4.4-1) unstable; urgency=medium

  * [2813e0b] New upstream version 1.4.3
  * [583b131] New upstream version 1.4.4 (Closes: LP#1957746)
  * [e005fb4] debian/patches/: drop 1741.patch and gcc-11.patch, both now
    upstream; refresh remaining patches
  * [836713c] debian/copyright: completely cover the new upstream release
  * [1ed3278] debian/{libsrt-doc.doc-base,conf.py}: follow upstream's doc
    reorg
  * [6215261] debian/control: provide individual Description per package
  * [6aee7c9] debian/libsrt-doc.examples: install upstream examples as well
  * [a412bcf] debian/patches/typo.patch: fix a typo present in various
    binaries
  * [2484989] debian/patches/: forward remaining patches upstream where needed
  * [f1b3b04] debian/rules: build with sphinxdoc, adding libjs-sphinxdoc to
    docs package
  * [0c3db08] add lintian-overrides for package-name-doesnt-match-sonames as
    the package name also reflects the library used to enable encryption
  * [87e7896] add lintian-overrides for no-symbols-control-file.
    C++ library with over 1000 exported symbols, so let's stick with shlibs
  * [fd1c8ab] debian/control: add 'Suggests: ffmpeg' to 'Package: srt-tools'
    due to usr/bin/srt-ffplay
  * [31d7d79] pkgconfig files are installed separately, so exclude them from
    *.install
  * [36e1ffe] debian/{clean,rules,srt-tools.install}: drop stransmit extra
    binary; no need to copy (and not even symlink) a binary that nothing uses
  * [2ca1fc8] debian/control: drop unused B-D chrpath and tclsh
  * [9181f3b] provide remaining manpages (albeit minimal) and clean up
    help2man calls
  * [ca08c12] debian/control: Standards-Version: 4.6.0.1 (no further changes
    required)
  * [c93b8a3] debian/rules: cleanup, much relying on dh's defaults for the
    right thing

 -- Florian Ernst <florian@debian.org>  Wed, 02 Mar 2022 21:33:49 +0100

=== debian/control ===
Source: srt
Priority: optional
Maintainer: Florian Ernst <florian@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 help2man,
 libgnutls28-dev,
 libgtest-dev,
 libssl-dev,
 pkg-config,
Build-Depends-Indep: python3-sphinx
Standards-Version: 4.6.0.1
Section: libs
Homepage: https://github.com/Haivision/srt
Vcs-Browser: https://salsa.debian.org/debian/libsrt
Vcs-Git: https://salsa.debian.org/debian/libsrt.git
Rules-Requires-Root: no

Package: libsrt1.4-openssl
Architecture: any
Breaks: libsrt1 (<< 1.4.1-3), libsrt1-openssl
Replaces: libsrt1 (<< 1.4.1-3), libsrt1-openssl
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by OpenSSL.

Package: libsrt1.4-gnutls
Architecture: any
Breaks: libsrt1-gnutls
Replaces: libsrt1-gnutls
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by GnuTLS.

Package: libsrt-openssl-dev
Section: libdevel
Breaks: libsrt-dev (<< 1.4.1-2)
Replaces: libsrt-dev (<< 1.4.1-2)
Architecture: any
Multi-Arch: same
Conflicts: libsrt-gnutls-dev, libsrt-dev
Depends: libsrt1.4-openssl (= ${binary:Version}), ${misc:Depends}
Suggests: libsrt-doc (= ${binary:Version}), libssl-dev (>= 1.1)
Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour development)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1.4
 SSL support is provided by OpenSSL.

Package: libsrt-gnutls-dev
Section: libdevel
Breaks: libsrt-dev (<< 1.4.1-2)
Replaces: libsrt-dev (<< 1.4.1-2)
Architecture: any
Multi-Arch: same
Conflicts: libsrt-openssl-dev, libsrt-dev
Depends: libsrt1.4-gnutls (= ${binary:Version}), ${misc:Depends}
Suggests: libsrt-doc (= ${binary:Version}), libgnutls28-dev
Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour development)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1.4-gnutls
 SSL support is provided by GnuTLS.

Package: libsrt-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Secure Reliable Transport UDP streaming library (documentation)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains documentation files for libsrt1.4

Package: srt-tools
Architecture: any
Section: utils
Multi-Arch: foreign
Depends: libsrt1.4-gnutls (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: ffmpeg
Description: Secure Reliable Transport UDP streaming library (CLI tools)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains CLI tools.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Standardized flags from /usr/share/perl5/Debian/Debhelper/Buildsystem/cmake.pm.
CMAKE_OPTS := -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON
# Enable some features that are disabled by default
EXTRA_OPTS := -DENABLE_UNITTESTS=ON # requires libgtest-dev
# -DENABLE_EXAMPLES=ON -> Example Apps -> will be installed in source form and handled via autopkgtests
# -DENABLE_TESTING=ON  -> DEVEL APPS (testing), some with rather generic names -> no need to install
# Restrict upstream unit testing to architectures upstream focuses on (and some where the tests succeed nonetheless)
test_archs = amd64 i386 arm64 armel armhf mips64el mipsel riscv64 x32

include /usr/share/dpkg/default.mk  # provides DEB_VERSION

%:
	dh $@ --buildsystem=cmake+makefile $(DH_ADDONS)
build binary %-indep: DH_ADDONS=--with=sphinxdoc

override_dh_auto_configure-arch:
	dh_auto_configure --builddirectory=build-openssl -- $(CMAKE_OPTS) $(EXTRA_OPTS) -DUSE_ENCLIB=openssl
	dh_auto_configure --builddirectory=build-gnutls -- $(CMAKE_OPTS) $(EXTRA_OPTS) -DUSE_ENCLIB=gnutls -DTARGET_srt=srt-gnutls

# not needed for arch-indep only builds
override_dh_auto_configure-indep:

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=build-openssl
	dh_auto_build --builddirectory=build-gnutls

override_dh_auto_build-indep:
	http_proxy='http://127.0.0.1:9/' sphinx-build -N -c debian -d debian/doctrees -bhtml docs debian/html

override_dh_auto_install-arch:
	dh_auto_install --builddirectory=build-openssl
	dh_auto_install --builddirectory=build-gnutls # this overwrites the *.pc files so we later need to install them from the respective builddirectory

# unbreak arch-indep only builds
override_dh_auto_install-indep:

override_dh_installman-arch:
	help2man --help-option=-help --no-discard-stderr --no-info --version-string="$(DEB_VERSION)" \
	--name "SRT sample application to transmit files" \
	-o ./debian/srt-file-transmit.1 ./build-gnutls/srt-file-transmit
	help2man --help-option=-help --no-discard-stderr --no-info --version-string="$(DEB_VERSION)" \
	--name "SRT sample application to transmit live streaming" \
	-o ./debian/srt-live-transmit.1 ./build-gnutls/srt-live-transmit
	dh_installman

# unbreak arch-indep only builds
override_dh_installman-indep:

override_dh_auto_test-arch:
ifneq (,$(filter $(DEB_HOST_ARCH), $(test_archs)))
	# must be executed consecutively lest they interfer with each other!
	dh_auto_test --no-parallel --builddirectory=build-openssl
	dh_auto_test --no-parallel --builddirectory=build-gnutls
endif

# unbreak arch-indep only builds
override_dh_auto_test-indep:

=== debian/tests/control ===
Test-Command: debian/tests/build gnutls
Depends:
 build-essential,
 pkg-config,
 libsrt-gnutls-dev,
 libgnutls28-dev
Restrictions: allow-stderr

Test-Command: debian/tests/build-cpp gnutls
Depends:
 build-essential,
 pkg-config,
 libsrt-gnutls-dev,
 libgnutls28-dev
Restrictions: allow-stderr, flaky

Test-Command: debian/tests/build openssl
Depends:
 build-essential,
 pkg-config,
 libsrt-openssl-dev,
 libssl-dev (>= 1.1)
Restrictions: allow-stderr

Test-Command: debian/tests/build-cpp openssl
Depends:
 build-essential,
 pkg-config,
 libsrt-openssl-dev,
 libssl-dev (>= 1.1)
Restrictions: allow-stderr, flaky

## srt 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 #
 
 cmake_minimum_required (VERSION 2.8.12 FATAL_ERROR)
-set (SRT_VERSION 1.4.4)
+set (SRT_VERSION 1.5.0)
 
 set (CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts")
 include(haiUtil) # needed for set_version_variables
@@ -94,7 +94,7 @@
 
 # SRT_ENABLE_ECN 1                /* Early Congestion Notification (for source bitrate control) */
 # SRT_DEBUG_TSBPD_OUTJITTER 1     /* Packet Delivery histogram */
-# SRT_DEBUG_TSBPD_DRIFT 1         /* Debug Encoder-Decoder Drift) */
+# SRT_DEBUG_TRACE_DRIFT 1         /* Create a trace log for Encoder-Decoder Clock Drift */
 # SRT_DEBUG_TSBPD_WRAP 1          /* Debug packet timestamp wraparound */
 # SRT_DEBUG_TLPKTDROP_DROPSEQ 1
 # SRT_DEBUG_SNDQ_HIGHRATE 1
@@ -123,9 +123,13 @@
 
 # options
 option(CYGWIN_USE_POSIX "Should the POSIX API be used for cygwin. Ignored if the system isn't cygwin." OFF)
-option(ENABLE_CXX11 "Should the c++11 parts (srt-live-transmit) be enabled" ON)
+if (CMAKE_CXX_COMPILER_ID MATCHES "^GNU$" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
+	option(ENABLE_CXX11 "Should the c++11 parts (srt-live-transmit) be enabled" OFF)
+else()
+	option(ENABLE_CXX11 "Should the c++11 parts (srt-live-transmit) be enabled" ON)
+endif()
 option(ENABLE_APPS "Should the Support Applications be Built?" ON)
-option(ENABLE_EXPERIMENTAL_BONDING "Should the EXPERIMENTAL bonding functionality be enabled?" OFF)
+option(ENABLE_BONDING "Should the bonding functionality be enabled?" OFF)
 option(ENABLE_TESTING "Should the Developer Test Applications be Built?" OFF)
 option(ENABLE_PROFILE "Should instrument the code for profiling. Ignored for non-GNU compiler." $ENV{HAI_BUILD_PROFILE})
 option(ENABLE_LOGGING "Should logging be enabled" ON)
@@ -144,9 +148,12 @@
 option(ENABLE_MONOTONIC_CLOCK "Enforced clock_gettime with monotonic clock on GC CV" ${ENABLE_MONOTONIC_CLOCK_DEFAULT})
 option(ENABLE_STDCXX_SYNC "Use C++11 chrono and threads for timing instead of pthreads" ${ENABLE_STDCXX_SYNC_DEFAULT})
 option(USE_OPENSSL_PC "Use pkg-config to find OpenSSL libraries" ON)
+option(OPENSSL_USE_STATIC_LIBS "Link OpenSSL libraries statically." OFF)
 option(USE_BUSY_WAITING "Enable more accurate sending times at a cost of potentially higher CPU load" OFF)
 option(USE_GNUSTL "Get c++ library/headers from the gnustl.pc" OFF)
 option(ENABLE_SOCK_CLOEXEC "Enable setting SOCK_CLOEXEC on a socket" ON)
+option(ENABLE_SHOW_PROJECT_CONFIG "Enable show Project Configuration" OFF)
+option(ENABLE_NEW_RCVBUFFER "Enable new receiver buffer implementation" ON)
 
 option(ENABLE_CLANG_TSA "Enable Clang Thread Safety Analysis" OFF)
 
@@ -200,7 +207,6 @@
 	else()
 		set (USE_ENCLIB openssl)
 	endif()
-
 endif()
 
 set(USE_ENCLIB "${USE_ENCLIB}" CACHE STRING "The crypto library that SRT uses")
@@ -297,22 +303,3 @@
 
 if (ENABLE_ENCRYPTION)
 	if ("${USE_ENCLIB}" STREQUAL "gnutls")
-		set (SSL_REQUIRED_MODULES "gnutls nettle")
-		if (WIN32)
-			if (MINGW)
-				set (SSL_REQUIRED_MODULES "${SSL_REQUIRED_MODULES} zlib")
-			endif()
-		endif()
-
-		pkg_check_modules (SSL REQUIRED ${SSL_REQUIRED_MODULES})
-
-		add_definitions(
-			-DUSE_GNUTLS=1
-		)
-
-		link_directories(
-			${SSL_LIBRARY_DIRS}
-		)
-	elseif ("${USE_ENCLIB}" STREQUAL "mbedtls")
-		add_definitions(-DUSE_MBEDTLS=1)
-		if ("${SSL_LIBRARY_DIRS}" STREQUAL "")

=== debian/changelog ===
srt (1.5.0-2) unstable; urgency=medium

  * Uploading to unstable to start the transition (cf. #1013670)
  * [4d90375] *-dev: Suggest libsrt-doc (= ${source:Version}) as it won't be
    binNMU'd
  * [b3fc582] disable tests that are prone to fail with noisy neighbours
  * [dcc7160] autopkgtest: skip flaky build-cpp execution step
  * [0b0250c] Standards-Version: 4.6.1.0 (no further changes required)

 -- Florian Ernst <florian@debian.org>  Sat, 02 Jul 2022 11:41:50 +0200

srt (1.5.0-1) experimental; urgency=medium

  * [bba9615] document where test suite failure reports have been filed
  * [64de987] New upstream version 1.5.0
  * [c8c35b3] drop patches applied upstream and refresh remaining
  * [af20837] debian/rules: show project configuration during build
  * [5ad9184] upstream changed the soname from 1.4 to 1.5, so adjust packaging
    accordingly; thus now upload to experimental

 -- Florian Ernst <florian@debian.org>  Fri, 17 Jun 2022 14:25:10 +0200

## srt 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,20 +8,20 @@
 #
 
 cmake_minimum_required (VERSION 2.8.12 FATAL_ERROR)
-set (SRT_VERSION 1.5.0)
+set (SRT_VERSION 1.5.1)
 
 set (CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts")
 include(haiUtil) # needed for set_version_variables
 # CMake version 3.0 introduced the VERSION option of the project() command
 # to specify a project version as well as the name.
 if(${CMAKE_VERSION} VERSION_LESS "3.0.0")
-  project(SRT C CXX)
-  # Sets SRT_VERSION_MAJOR, SRT_VERSION_MINOR, SRT_VERSION_PATCH
-  set_version_variables(SRT_VERSION ${SRT_VERSION})
-else()
-  cmake_policy(SET CMP0048 NEW)
-  # Also sets SRT_VERSION_MAJOR, SRT_VERSION_MINOR, SRT_VERSION_PATCH
-  project(SRT VERSION ${SRT_VERSION} LANGUAGES C CXX)
+	project(SRT C CXX)
+	# Sets SRT_VERSION_MAJOR, SRT_VERSION_MINOR, SRT_VERSION_PATCH
+	set_version_variables(SRT_VERSION ${SRT_VERSION})
+else()
+	cmake_policy(SET CMP0048 NEW)
+	# Also sets SRT_VERSION_MAJOR, SRT_VERSION_MINOR, SRT_VERSION_PATCH
+	project(SRT VERSION ${SRT_VERSION} LANGUAGES C CXX)
 endif()
 
 include(FindPkgConfig)
@@ -43,15 +43,9 @@
 set_if(SUNOS       "${SYSNAME_LC}" MATCHES "sunos")
 set_if(POSIX       LINUX OR DARWIN OR BSD OR SUNOS OR ANDROID OR (CYGWIN AND CYGWIN_USE_POSIX))
 set_if(SYMLINKABLE LINUX OR DARWIN OR BSD OR SUNOS OR CYGWIN OR GNU)
-
-# Not sure what to do in case of compiling by MSVC.
-# This will make installdir in C:\Program Files\SRT then
-# inside "bin" and "lib64" directories. At least this maintains
-# the current status. Shall this be not desired, override values
-# of CMAKE_INSTALL_BINDIR, CMAKE_INSTALL_LIBDIR and CMAKE_INSTALL_INCLUDEDIR.
-if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
-	include(GNUInstallDirs)
-endif()
+set_if(NEED_DESTINATION  ${CMAKE_VERSION} VERSION_LESS "3.14.0")
+
+include(GNUInstallDirs)
 
 # The CMAKE_BUILD_TYPE seems not to be always set, weird.
 if (NOT DEFINED ENABLE_DEBUG)
@@ -63,15 +57,28 @@
 	endif()
 endif()
 
-# Set CMAKE_BUILD_TYPE properly, now that you know
-# that ENABLE_DEBUG is set as it should.
-
-if (ENABLE_DEBUG EQUAL 2)
-	set (CMAKE_BUILD_TYPE "RelWithDebInfo")
-elseif (ENABLE_DEBUG) # 1, ON, YES, TRUE, Y, or any other non-zero number
-	set (CMAKE_BUILD_TYPE "Debug")
-else()
-	set (CMAKE_BUILD_TYPE "Release")
+# XXX This is a kind of workaround - this part to set the build
+# type and associated other flags should not be done for build
+# systems (cmake generators) that generate a multi-configuration
+# build definition. At least it is known that MSVC does it and it
+# sets _DEBUG and NDEBUG flags itself, so this shouldn't be done
+# at all in this case.
+if (NOT MICROSOFT)
+
+	# Set CMAKE_BUILD_TYPE properly, now that you know
+	# that ENABLE_DEBUG is set as it should.
+	if (ENABLE_DEBUG EQUAL 2)
+		set (CMAKE_BUILD_TYPE "RelWithDebInfo")
+		add_definitions(-DNDEBUG)
+	elseif (ENABLE_DEBUG) # 1, ON, YES, TRUE, Y, or any other non-zero number
+		set (CMAKE_BUILD_TYPE "Debug")
+
+		# Add _DEBUG macro in debug mode only, to enable SRT_ASSERT().
+		add_definitions(-D_DEBUG)
+	else()
+		set (CMAKE_BUILD_TYPE "Release")
+		add_definitions(-DNDEBUG)
+	endif()
 endif()
 
 message(STATUS "BUILD TYPE: ${CMAKE_BUILD_TYPE}")
@@ -296,10 +303,3 @@
 if (ENABLE_MONOTONIC_CLOCK)
 	if (NOT ENABLE_MONOTONIC_CLOCK_DEFAULT)
 		message(FATAL_ERROR "Your platform does not support CLOCK_MONOTONIC. Build with -DENABLE_MONOTONIC_CLOCK=OFF.")
-	endif()
-	set (WITH_EXTRALIBS "${WITH_EXTRALIBS} ${MONOTONIC_CLOCK_LINKLIB}")
-	add_definitions(-DENABLE_MONOTONIC_CLOCK=1)
-endif()
-
-if (ENABLE_ENCRYPTION)
-	if ("${USE_ENCLIB}" STREQUAL "gnutls")

=== debian/changelog ===
srt (1.5.1-1+deb12u1) bookworm; urgency=medium

  * [1e9db13] d/control: correct hard dependencies for dev packages.
    Thanks to Laurent Bigonville <bigon@debian.org> (Closes: #1086751)

 -- Florian Ernst <florian@debian.org>  Fri, 08 Nov 2024 15:09:06 +0100

srt (1.5.1-1) unstable; urgency=medium

  * [cd32285] New upstream version 1.5.1
  * [73df5e2] debian/patches/*.patch: refresh, dropping now-obsolete
    include(GNUInstallDirs)
  * [952b715] debian/*.lintian-overrides: match other archs and newer versions
    as well

 -- Florian Ernst <florian@debian.org>  Wed, 28 Sep 2022 16:46:38 +0200

=== debian/control ===
--- 
+++ 
@@ -9,14 +9,14 @@
  libssl-dev,
  pkg-config,
 Build-Depends-Indep: python3-sphinx
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Section: libs
 Homepage: https://github.com/Haivision/srt
 Vcs-Browser: https://salsa.debian.org/debian/libsrt
 Vcs-Git: https://salsa.debian.org/debian/libsrt.git
 Rules-Requires-Root: no
 
-Package: libsrt1.4-openssl
+Package: libsrt1.5-openssl
 Architecture: any
 Breaks: libsrt1 (<< 1.4.1-3), libsrt1-openssl
 Replaces: libsrt1 (<< 1.4.1-3), libsrt1-openssl
@@ -29,7 +29,7 @@
  .
  SSL support is provided by OpenSSL.
 
-Package: libsrt1.4-gnutls
+Package: libsrt1.5-gnutls
 Architecture: any
 Breaks: libsrt1-gnutls
 Replaces: libsrt1-gnutls
@@ -49,14 +49,16 @@
 Architecture: any
 Multi-Arch: same
 Conflicts: libsrt-gnutls-dev, libsrt-dev
-Depends: libsrt1.4-openssl (= ${binary:Version}), ${misc:Depends}
-Suggests: libsrt-doc (= ${binary:Version}), libssl-dev (>= 1.1)
+Depends: libsrt1.5-openssl (= ${binary:Version}),
+         libssl-dev (>= 1.1),
+         ${misc:Depends},
+Suggests: libsrt-doc (= ${source:Version}),
 Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour development)
  SRT is a latency-aware UDP transport mechanism optimized for video streams.
  It detects and compensates for jitter and bandwidth fluctuations due to
  network congestion. It mitigates packet loss and supports AES encryption.
  .
- This package contains development files for libsrt1.4
+ This package contains development files for libsrt1.5
  SSL support is provided by OpenSSL.
 
 Package: libsrt-gnutls-dev
@@ -66,14 +68,17 @@
 Architecture: any
 Multi-Arch: same
 Conflicts: libsrt-openssl-dev, libsrt-dev
-Depends: libsrt1.4-gnutls (= ${binary:Version}), ${misc:Depends}
-Suggests: libsrt-doc (= ${binary:Version}), libgnutls28-dev
+Depends: libgnutls28-dev,
+         libsrt1.5-gnutls (= ${binary:Version}),
+         nettle-dev,
+         ${misc:Depends},
+Suggests: libsrt-doc (= ${source:Version}),
 Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour development)
  SRT is a latency-aware UDP transport mechanism optimized for video streams.
  It detects and compensates for jitter and bandwidth fluctuations due to
  network congestion. It mitigates packet loss and supports AES encryption.
  .
- This package contains development files for libsrt1.4-gnutls
+ This package contains development files for libsrt1.5-gnutls
  SSL support is provided by GnuTLS.
 
 Package: libsrt-doc
@@ -86,13 +91,13 @@
  It detects and compensates for jitter and bandwidth fluctuations due to
  network congestion. It mitigates packet loss and supports AES encryption.
  .
- This package contains documentation files for libsrt1.4
+ This package contains documentation files for libsrt1.5
 
 Package: srt-tools
 Architecture: any
 Section: utils
 Multi-Arch: foreign
-Depends: libsrt1.4-gnutls (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libsrt1.5-gnutls (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Suggests: ffmpeg
 Description: Secure Reliable Transport UDP streaming library (CLI tools)
  SRT is a latency-aware UDP transport mechanism optimized for video streams.

=== debian/rules ===
--- 
+++ 
@@ -7,10 +7,11 @@
 # Standardized flags from /usr/share/perl5/Debian/Debhelper/Buildsystem/cmake.pm.
 CMAKE_OPTS := -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON
 # Enable some features that are disabled by default
-EXTRA_OPTS := -DENABLE_UNITTESTS=ON # requires libgtest-dev
+EXTRA_OPTS := -DENABLE_SHOW_PROJECT_CONFIG=ON -DENABLE_UNITTESTS=ON # unit tests require libgtest-dev
 # -DENABLE_EXAMPLES=ON -> Example Apps -> will be installed in source form and handled via autopkgtests
 # -DENABLE_TESTING=ON  -> DEVEL APPS (testing), some with rather generic names -> no need to install
 # Restrict upstream unit testing to architectures upstream focuses on (and some where the tests succeed nonetheless)
+# test suite failures reported at https://github.com/Haivision/srt/issues/2267
 test_archs = amd64 i386 arm64 armel armhf mips64el mipsel riscv64 x32
 
 include /usr/share/dpkg/default.mk  # provides DEB_VERSION

## srt 1.5.2

=== debian/changelog ===
srt (1.5.2-1) unstable; urgency=medium

  * [c327281] New upstream version 1.5.2
  * [13d11c8] debian/copyright: update year and drop reference to delete files
  * [ac92db8] debian/patches/*: refresh
  * [26171e9] debian/rules: drop obsolete "DEB_LDFLAGS_MAINT_APPEND =
    -Wl,--as-needed"
  * [94704d3] debian/control: drop obsolete Breaks/Replaces
  * [18ae0d2] debian/control: Standards-Version: 4.6.2 (no further changes
    required)

 -- Florian Ernst <florian@debian.org>  Sat, 01 Jul 2023 14:39:31 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  libssl-dev,
  pkg-config,
 Build-Depends-Indep: python3-sphinx
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/Haivision/srt
 Vcs-Browser: https://salsa.debian.org/debian/libsrt
@@ -18,8 +18,6 @@
 
 Package: libsrt1.5-openssl
 Architecture: any
-Breaks: libsrt1 (<< 1.4.1-3), libsrt1-openssl
-Replaces: libsrt1 (<< 1.4.1-3), libsrt1-openssl
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour)
@@ -31,8 +29,6 @@
 
 Package: libsrt1.5-gnutls
 Architecture: any
-Breaks: libsrt1-gnutls
-Replaces: libsrt1-gnutls
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour)
@@ -44,15 +40,11 @@
 
 Package: libsrt-openssl-dev
 Section: libdevel
-Breaks: libsrt-dev (<< 1.4.1-2)
-Replaces: libsrt-dev (<< 1.4.1-2)
 Architecture: any
 Multi-Arch: same
 Conflicts: libsrt-gnutls-dev, libsrt-dev
-Depends: libsrt1.5-openssl (= ${binary:Version}),
-         libssl-dev (>= 1.1),
-         ${misc:Depends},
-Suggests: libsrt-doc (= ${source:Version}),
+Depends: libsrt1.5-openssl (= ${binary:Version}), ${misc:Depends}
+Suggests: libsrt-doc (= ${source:Version}), libssl-dev (>= 1.1)
 Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour development)
  SRT is a latency-aware UDP transport mechanism optimized for video streams.
  It detects and compensates for jitter and bandwidth fluctuations due to
@@ -63,16 +55,11 @@
 
 Package: libsrt-gnutls-dev
 Section: libdevel
-Breaks: libsrt-dev (<< 1.4.1-2)
-Replaces: libsrt-dev (<< 1.4.1-2)
 Architecture: any
 Multi-Arch: same
 Conflicts: libsrt-openssl-dev, libsrt-dev
-Depends: libgnutls28-dev,
-         libsrt1.5-gnutls (= ${binary:Version}),
-         nettle-dev,
-         ${misc:Depends},
-Suggests: libsrt-doc (= ${source:Version}),
+Depends: libsrt1.5-gnutls (= ${binary:Version}), ${misc:Depends}
+Suggests: libsrt-doc (= ${source:Version}), libgnutls28-dev
 Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour development)
  SRT is a latency-aware UDP transport mechanism optimized for video streams.
  It detects and compensates for jitter and bandwidth fluctuations due to

## srt 1.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 #
 
 cmake_minimum_required (VERSION 2.8.12 FATAL_ERROR)
-set (SRT_VERSION 1.5.1)
+set (SRT_VERSION 1.5.3)
 
 set (CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts")
 include(haiUtil) # needed for set_version_variables
@@ -117,6 +117,9 @@
 	set(ENABLE_HEAVY_LOGGING_DEFAULT ON)
 endif()
 
+# Note that the IP_PKTINFO  has a limited portability and may not work on some platforms
+# (Windows, FreeBSD, ...).
+set (ENABLE_PKTINFO_DEFAULT OFF)
 
 set(ENABLE_STDCXX_SYNC_DEFAULT OFF)
 set(ENABLE_MONOTONIC_CLOCK_DEFAULT OFF)
@@ -144,10 +147,13 @@
 option(ENABLE_HAICRYPT_LOGGING "Should logging in haicrypt be enabled" 0)
 option(ENABLE_SHARED "Should libsrt be built as a shared library" ON)
 option(ENABLE_STATIC "Should libsrt be built as a static library" ON)
+option(ENABLE_PKTINFO "Enable using IP_PKTINFO to allow the listener extracting the target IP address from incoming packets" ${ENABLE_PKTINFO_DEFAULT})
 option(ENABLE_RELATIVE_LIBPATH "Should application contain relative library paths, like ../lib" OFF)
 option(ENABLE_GETNAMEINFO "In-logs sockaddr-to-string should do rev-dns" OFF)
 option(ENABLE_UNITTESTS "Enable unit tests" OFF)
 option(ENABLE_ENCRYPTION "Enable encryption in SRT" ON)
+option(ENABLE_AEAD_API_PREVIEW "Enable AEAD API preview in SRT" Off)
+option(ENABLE_MAXREXMITBW "Enable SRTO_MAXREXMITBW (v1.6.0 API preview)" Off)
 option(ENABLE_CXX_DEPS "Extra library dependencies in srt.pc for the CXX libraries useful with C language" ON)
 option(USE_STATIC_LIBSTDCXX "Should use static rather than shared libstdc++" OFF)
 option(ENABLE_INET_PTON "Set to OFF to prevent usage of inet_pton when building against modern SDKs while still requiring compatibility with older Windows versions, such as Windows XP, Windows Server 2003 etc." ON)
@@ -160,7 +166,6 @@
 option(USE_GNUSTL "Get c++ library/headers from the gnustl.pc" OFF)
 option(ENABLE_SOCK_CLOEXEC "Enable setting SOCK_CLOEXEC on a socket" ON)
 option(ENABLE_SHOW_PROJECT_CONFIG "Enable show Project Configuration" OFF)
-option(ENABLE_NEW_RCVBUFFER "Enable new receiver buffer implementation" ON)
 
 option(ENABLE_CLANG_TSA "Enable Clang Thread Safety Analysis" OFF)
 
@@ -198,6 +203,16 @@
 	list(APPEND SRT_EXTRA_CFLAGS "-DUSE_BUSY_WAITING=1")
 else()
 	message(STATUS "USE_BUSY_WAITING: OFF (default)")
+endif()
+
+# Reduce the frequency of some frequent logs, milliseconds
+set(SRT_LOG_SLOWDOWN_FREQ_MS_DEFAULT 1000) # 1s
+if (NOT DEFINED SRT_LOG_SLOWDOWN_FREQ_MS)
+	if (ENABLE_HEAVY_LOGGING)
+		set(SRT_LOG_SLOWDOWN_FREQ_MS 0) # Just show every log message.
+	else()
+		set(SRT_LOG_SLOWDOWN_FREQ_MS ${SRT_LOG_SLOWDOWN_FREQ_MS_DEFAULT})
+	endif()
 endif()
 
 if ( CYGWIN AND NOT CYGWIN_USE_POSIX )
@@ -279,27 +294,3 @@
 
 # When you use crosscompiling, you have to take care that PKG_CONFIG_PATH
 # and CMAKE_PREFIX_PATH are set properly.
-
-# symbol exists in win32, but function does not.
-if(WIN32)
-	if(ENABLE_INET_PTON)
-		set(CMAKE_REQUIRED_LIBRARIES ws2_32)
-		check_function_exists(inet_pton HAVE_INET_PTON)
-		add_definitions(-D_WIN32_WINNT=0x0600)
-	else()
-		add_definitions(-D_WIN32_WINNT=0x0501)
-	endif()
-else()
-	check_function_exists(inet_pton HAVE_INET_PTON)
-endif()
-if (DEFINED HAVE_INET_PTON)
-	add_definitions(-DHAVE_INET_PTON=1)
-endif()
-
-# Defines HAVE_PTHREAD_GETNAME_* and HAVE_PTHREAD_SETNAME_*
-include(FindPThreadGetSetName)
-FindPThreadGetSetName()
-
-if (ENABLE_MONOTONIC_CLOCK)
-	if (NOT ENABLE_MONOTONIC_CLOCK_DEFAULT)
-		message(FATAL_ERROR "Your platform does not support CLOCK_MONOTONIC. Build with -DENABLE_MONOTONIC_CLOCK=OFF.")

=== debian/changelog ===
srt (1.5.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:24:57 +0000

srt (1.5.3-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:26:26 +0000

srt (1.5.3-1) unstable; urgency=medium

  * [bbcc570] New upstream version 1.5.3
  * [636e97a] debian/patches/001-multiarch-rpath.patch: refresh

 -- Florian Ernst <florian@debian.org>  Sat, 16 Sep 2023 12:43:23 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: srt
 Priority: optional
-Maintainer: Florian Ernst <florian@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Florian Ernst <florian@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
  help2man,

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,6 @@
 export DH_VERBOSE = 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 # Standardized flags from /usr/share/perl5/Debian/Debhelper/Buildsystem/cmake.pm.
 CMAKE_OPTS := -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=None -DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON
